## Introduction

Halo is an open-source OSM (OpenStreetMap) route optimization engine. Built on FastAPI, this RESTful backend provides efficient route calculation and data processing. Leveraging SQLAlchemy for database management and Redis for fast data access, the project maximizes performance.

## Key Features

- **Route Optimization**: Utilizes OSM data to provide accurate route optimization.
- **High-Performance Backend**: Developed with FastAPI for fast and efficient service.
- **Data Management**: Supports structured database management with SQLAlchemy.
- **Caching Mechanism**: Enhances repetitive data request processing speeds using Redis.

## Technology Stack

- **FastAPI**: A modern, fast web framework for easy API development.
- **SQLAlchemy**: Offers powerful SQL toolkit and ORM (Object-Relational Mapping).
- **Redis**: A high-performance key-value store used for data caching.
- **OpenStreetMap**: Provides map data necessary for route optimization, free to use.

## Installation and Execution

```bash
git clone https://github.com/yourusername/halo.git
cd halo
docker-compose up -d
```


![image](https://github.com/lavi02/Halo/assets/55977356/d1b2efd2-3b29-4e39-b56d-34bf008896c2)
